<?php
// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// ----------------------------------------------------------------------------
// Original Author of this file: Francisco Burzi
// Purpose of this file: Directs to the start page as defined in config.php
// ----------------------------------------------------------------------------

include 'includes/pnAPI.php';
pnInit();

// Get variables
list($module,
        $func,
        $op,
        $name,
        $file,
     $type,) = pnVarCleanFromInput('module',
                                                                'func',
                                                                'op',
                                                                'name',
                                                                'file',
                                                                'type');

// Defaults for variables

if (isset($catid)) {
	pnVarCleanFromInput('catid');
}

if (empty($op)) {
    $op = "modload";
}
if (empty($name)) {
    $name= pnConfigGetVar('startpage');
}

if (empty($type))
{
        $type = 'user';
}

if (empty($file))
{
        $file="index";
}

if (!empty($module))
{
        // New-new style of loading modules

        // Load the module
        $loadedmod = pnModLoad($module, $type);
        if (empty($loadedmod))
        {
                // Failed to load the module
                $output = new pnHTML();
                $output->StartPage();

                $output->Text('Failed to load module ' . $module);

                $output->EndPage();
                $output->PrintPage();
                exit;
        }

        // Inserted for Encompass
        // eugeniobaldi 020826
        $output = new pnHTML();
        $output->StartPage();

        // Run the function
        $return = pnModFunc($loadedmod, $type, $func);

        if (function_exists('session_write_close'))
        {
                session_write_close();
        }

        // Sort out return of function.  Can be
        // true - finished
        // false - need to redirect to module's
        //         main page
        // text - return information

        if ((empty($return)) || ($return == false))
        {
                pnRedirect(pnModURL($module, $type));
    } elseif (strlen($return) > 1) {

// Begin expanded pnHTML for RteMulti
                if ((pnModGetVar('RteMulti','RteEnable')==1)and(pnModAvailable('RteMulti'))) {
                        include_once( "modules/RteMulti/pnRTEHTML.php" );
                $output = new pnRTEHTML();
                 $output->SetInputMode(_PNH_VERBATIMINPUT);
                        $output->Text($return);

                        // holder for pnHTML object for Encompass interface
                        $my_content = $output->GetOutput();
                        $output->SetInputMode(_PNH_PARSEINPUT);
                        //include ("footer.php");

                    if (!pnModAPILoad('rtemulti', 'user')) {
                        $output->Text(_LOADFAILED);
                        return $output->GetOutput();
                    }
                } else {
                 $output = new pnHTML();
                  $output->SetInputMode(_PNH_VERBATIMINPUT);
                        $output->Text($return);

                        // holder for pnHTML object for Encompass interface
                        $my_content = $output->GetOutput();
                        $output->SetInputMode(_PNH_PARSEINPUT);
                        include ("footer.php");



                }
// End expand

//                 $output = new pnHTML();        // comment out for RTE 25.09.2002 WindMeUp

// if CE call his own "print-function", then no StartPage
    if (strcmp($func,"print") != 0) {
        $output->StartPage();
        }
// End CE-print [begin part]

// Begin modification for PN + RTE + CE + Encompass
//***********************************************************
// for Encompass there must use some heavy changes with some more buffers
// and a modified pnRTEHTML
//
                if (class_exists('Encompass'))
                {
                        // <apathy>                Headers already started by StartPage();
                        //                                also newpnHTML was added to fix layout issues
                        //include ("header.php");
                        $output = new pnHTML();
                        $output->SetInputMode(_PNH_VERBATIMINPUT);
                        $output->Text($return);

                        // holder for pnHTML object for Encompass interface
                        $my_content = $output->GetOutput();
                        $output->SetInputMode(_PNH_PARSEINPUT);
                        //
// including for RteMulti
                if ((pnModGetVar('RteMulti','RteEnable')==1)and(pnModAvailable('RteMulti'))) {
                        ob_start();
                        include ("footer.php");
                $return = ob_get_contents();
                ob_end_clean();
                        $output = new pnRTEHTML();
                        ob_start();

                        $output->ManipulatePage($return);
                $output = ob_get_contents();
                ob_end_clean();
                        print $output;

                }
// End including
//
 } else {
                        // <mh7>                StartPage() has already been called, not needed here
                        // $output->StartPage();
                        $output->SetInputMode(_PNH_VERBATIMINPUT);
                        $output->Text($return);
                        $output->SetInputMode(_PNH_PARSEINPUT);
                        $output->EndPage();
                        // if CE call print-func, then no EndPage and no RTE-manipulation
    if (strcmp($func,"print") != 0) {
        $output->EndPage();

// including for RteMulti
                if ((pnModGetVar('RteMulti','RteEnable')==1)and(pnModAvailable('RteMulti'))) {
                        $output->ManipulatePage();
                }
// End including

        }
// End CE-print [end part]

                $output->PrintPage();
                }
        }

        exit;
} else {
        // Old stuff
        include 'includes/legacy.php';

        switch ($op)
        {
                case 'modload':
                        if (!file_exists('modules/' . pnVarPrepForOS($name) . '/' . pnVarPrepForOS($file) . '.php')) {
                       pnRedirect(pnModURL('Errore', 'admin', 'main', array('op' => 'noexist','modname' => $name)));
                           break;
                           }
                        if (!pnModAvailable($name)) {
                          pnRedirect(pnModURL('Errore', 'admin', 'main', array('op' => 'noactive','modname' => $name)));
                           break;
                           }
                        define("LOADED_AS_MODULE", "1");
                        include 'modules/'.pnVarPrepForOS($name).'/'.pnVarPrepForOS($file).'.php';
                        break;
                default:
                        die ("Sorry, you can't access this file directly...");
                        break;
        }

        if (function_exists('session_write_close'))
        {
                session_write_close();
        } else {
                // Hack for old versions of PHP with bad session save
                $sessvars = '';
                foreach ($GLOBALS as $k => $v)
                {
                        if ((preg_match('/^PNSV/', $k)) && (isset($v)))
                        {
                                $sessvars .= "$k|" . serialize($v);
                        }
                }

                pnSessionWrite(session_id(), $sessvars);
        }
}


?>