<?php

// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//


/*

 * Smarty plugin

 * -------------------------------------------------------------

 * Type:     function

 * Name:     assign_debug_info

 * Purpose:  assign debug info to the template

 * -------------------------------------------------------------

 */

function smarty_function_assign_debug_info($params, &$smarty)

{

    $assigned_vars = $smarty->_tpl_vars;

    ksort($assigned_vars);

    if (@is_array($smarty->_config[0])) {

        $config_vars = $smarty->_config[0];

        ksort($config_vars);

        $smarty->assign("_debug_config_keys", array_keys($config_vars));

        $smarty->assign("_debug_config_vals", array_values($config_vars));

    }   

    

    $included_templates = $smarty->_smarty_debug_info;

    

    $smarty->assign("_debug_keys", array_keys($assigned_vars));

    $smarty->assign("_debug_vals", array_values($assigned_vars));

    

    $smarty->assign("_debug_tpls", $included_templates);

}



/* vim: set expandtab: */



?>

